//+------------------------------------------------------------------+
//|                                                        4 Bar.mq5 |
//|                                Copyright 2021, Mahadi Hasan Razu |
//|                      https://www.mql5.com/en/users/hermesmercury |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Mahadi Hasan Razu"
#property link      "https://www.mql5.com/en/users/hermesmercury"
#property version   "1.00"
#property indicator_chart_window

#property indicator_buffers 4
#property indicator_plots   4

#property indicator_type1   DRAW_ARROW
#property indicator_type2   DRAW_ARROW
#property indicator_type3   DRAW_ARROW
#property indicator_type4   DRAW_ARROW

#property indicator_color1  clrBlue
#property indicator_color2  clrBlue
#property indicator_color3  clrRed
#property indicator_color4  clrRed

#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2

#property indicator_label1  "4 Bar Buy"
#property indicator_label2  "4 Bar Buy"
#property indicator_label3  "4 Bar Sell"
#property indicator_label4  "4 Bar Sell"


input   bool       SoundAlert  =  false;


double up[], up_dot[];
double down[], down_dot[];

static datetime prevtime=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,up);
   SetIndexBuffer(1,up_dot);
   SetIndexBuffer(2,down);
   SetIndexBuffer(3,down_dot);
   
   PlotIndexSetInteger(0,PLOT_ARROW,241);
   PlotIndexSetInteger(1,PLOT_ARROW,108);
   PlotIndexSetInteger(2,PLOT_ARROW,242);
   PlotIndexSetInteger(3,PLOT_ARROW,108);
   
   PlotIndexSetInteger(0,PLOT_ARROW_SHIFT,15);
   PlotIndexSetInteger(2,PLOT_ARROW_SHIFT,-15);
   
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0.0);
   
   IndicatorSetString(INDICATOR_SHORTNAME,"4 Bar");
   
   if(ChartGetInteger(0,CHART_FOREGROUND))
      ChartSetInteger(0,CHART_FOREGROUND,false);
//---

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int i = prev_calculated-1; 
   if(i<0) i=3; 
   
   if(rates_total>prev_calculated)
   while(i<rates_total){
      
      up[i]=0; up_dot[i]=0; down[i]=0; down_dot[i]=0;
      
      if(close[i]>open[i] && close[i]>high[i-1] && close[i]>high[i-3]){
      up[i] = low[i];
      up_dot[i] = close[i];   
      }
      
      if(close[i]<open[i] && close[i]<low[i-1] && close[i]<low[i-3]){
      down[i] = high[i];
      down_dot[i] = close[i];
      }
      
   i++;
   }
   
   // Signal Alert
   if(up[rates_total-2]!=0 && prevtime!=time[rates_total-1] && SoundAlert){
         prevtime = time[rates_total-1];
         Alert(Symbol()," 4 Bar Buy");
         //PlaySound ("alert.wav");
      } 
      
      if(down[rates_total-2]!=0 && prevtime!=time[rates_total-1] && SoundAlert){
         prevtime=time[rates_total-1];
         Alert(Symbol()," 4 Bar Sell");
         //PlaySound ("alert.wav");
      } 
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
